/// <reference types="mdx-js__react" />
import { MDXProviderComponents } from '@mdx-js/react';
export { MDXProviderComponents } from '@mdx-js/react';
import { ReactHTML, CSSProperties, PropsWithChildren } from 'react';
import { Context } from 'twind';

declare type StyledIntrinsicFactories = {
    [TIntrinsic in keyof ReactHTML]: StyledHTML<TIntrinsic>;
};
interface StyledElements extends StyledIntrinsicFactories {
    <TIntrinsic extends keyof ReactHTML>(elementType: TIntrinsic): StyledHTML<TIntrinsic>;
    <T extends keyof ReactHTML>(elementType: T, strings: TemplateStringsArray, ...interpolations: readonly MaybeThunk<MaybeArray<CSSProperties | string | number | Falsy>>[]): ReactHTML[T];
    <T extends keyof ReactHTML>(elementType: T, tokens: MaybeThunk<MaybeArray<CSSProperties | Falsy>>): ReactHTML[T];
    <T extends keyof ReactHTML>(elementType: T, ...tokens: readonly MaybeThunk<CSSProperties | Falsy>[]): ReactHTML[T];
}
declare type Falsy = '' | 0 | -0 | false | null | undefined | void;
declare type MaybeArray<T> = T | readonly T[];
declare type MaybeThunk<T> = T | ((context: Context) => T);
interface StyledHTML<T extends keyof ReactHTML> {
    (strings: TemplateStringsArray, ...interpolations: readonly MaybeThunk<MaybeArray<CSSProperties | string | number | Falsy>>[]): ReactHTML[T];
    (tokens: MaybeThunk<MaybeArray<CSSProperties | Falsy>>): ReactHTML[T];
    (...tokens: readonly MaybeThunk<CSSProperties | Falsy>[]): ReactHTML[T];
}
declare const styled: StyledElements;

interface MDXProps extends PropsWithChildren<{
    components: MDXProviderComponents;
}> {
}

export { MDXProps, StyledElements, StyledIntrinsicFactories, styled };
